;Convert temp(low) & temp1 (hi) to ten thousands, thousands, hundreds, tens and units
;ten thousands, thousands, hundreds, tens and units must be assigned 5 registers
htod16:
	push	r19
	push	r18
	push	temp1
	push	temp
	ldi		r19,0x30			;Prepare r19 with ASCII 0
	ldi		r18,high(10000)
	cpi		temp,low(10000)
	cpc		temp1,r18
	brsh	do_ten_k			;>10,000	
	mov		ten_k,r19			;0 ten thousands
	ldi		r18,high(1000)
	cpi		temp,low(1000)
	cpc		temp1,r18
	brsh	do_one_k			;>1000
	mov		thousands,r19		;0 thousands
	ldi		r18,high(100)
	cpi		temp,low(100)
	cpc		temp1,r18
	brsh	do_hundreds			;>100
	mov		hundreds,r19		;0 hundreds
;Ignore temp1 as <100
	cpi		temp,10
	brsh	do_tens				;>10
	mov		tens,r19			;0 tens
less_than_10:
	add		temp,r19			;If <10 make number ASCII
	mov		units,temp
x_htod16:
	pop		temp
	pop		temp1	
	pop		r18
	pop		r19	
	ret
;r19 contains 0x30 already
do_ten_k:
	ldi		r18,high(10000)
	mov		ten_k,r19			;Prepare ten thousands with ASCII 0
	cpi		temp,low(10000)
	cpc		temp1,r18
	brlo	do_one_k	
lp_ten_ks:
	inc		ten_k
	subi	temp,low(10000)
	sbc		temp1,r18
	cpi		temp,low(10000)
	cpc		temp1,r18
	brsh	lp_ten_ks
do_one_k:
	ldi		r18,high(1000)
	mov		thousands,r19		;Prepare thousands with ASCII 0
	cpi		temp,low(1000)
	cpc		temp1,r18
	brlo	do_hundreds		
lp_one_k:
	inc		thousands
	subi	temp,low(1000)
	sbc		temp1,r18
	cpi		temp,low(1000)
	cpc		temp1,r18
	brsh	lp_one_k
do_hundreds:
	ldi		r18,high(100)
	mov		hundreds,r19		;Prepare hundreds with ASCII 0	
	cpi		temp,low(100)
	cpc		temp1,r18
	brlo	do_tens	
lp_100s:
	inc		hundreds
	subi	temp,low(100)
	sbc		temp1,r18
	cpi		temp,low(100)
	cpc		temp1,r18
	brsh	lp_100s
do_tens:	
	mov		tens,r19			;Prepare tens with ASCII 0
	cpi		temp,10
	brlo	no_tens	
lp_10s:	
	inc		tens
	subi	temp,10
	cpi		temp,10
	brsh	lp_10s
no_tens:	
	rjmp	less_than_10		;Back to units


;Convert ten thousands, thousands, hundreds, tens and units 
;to hex into temp(low) & temp1 (hi)
;ten thousands, thousands,hundreds, tens and units must be 
;assigned 5 register

dtoh16:
	clt							;Clear the T flag
	push	r20	
	clr		temp
	clr		temp1
	mov		r20,ten_k
	subi	r20,0x30			;Convert to hex
ten_k_lp:
	tst		r20
	breq	zero_ten_k
	subi	temp,low(-10000)	;Add 10000 to temp,temp1
	sbci	temp1,high(-10000)
	brvc	tk_lp				;Continue if not overflow
	set							;Indicate overflow
tk_lp:
	dec		r20
	rjmp	ten_k_lp		
zero_ten_k:	

	mov		r20,thousands
	subi	r20,0x30			;Convert to hex
thousands_lp:
	tst		r20
	breq	zero_thousands
	subi	temp,low(-1000)		;Add 1000 to temp,temp1
	sbci	temp1,high(-1000)
	brvc	k_lp				;Continue if not overflow
	set							;Indicate overflow
k_lp:
	dec		r20
	rjmp	thousands_lp
zero_thousands:	

	mov		r20,hundreds
	subi	r20,0x30			;Convert to hex
hundreds_lp:
	tst		r20
	breq	zero_hundreds
	subi	temp,low(-100)		;Add 100 to temp,temp1
	sbci	temp1,high(-100)
	brvc	h_lp				;Continue if not overflow
	set							;Indicate overflow
h_lp:
	dec		r20
	rjmp	hundreds_lp		
zero_hundreds:	

	mov		r20,tens
	subi	r20,0x30			;Convert to hex
tens_lp:
	tst		r20
	breq	zero_tens
	subi	temp,low(-10)		;Add 10 to temp,temp1
	sbci	temp1,high(-10)
	brvc	t_lp				;Continue if not overflow
	set							;Indicate overflow
t_lp:
	dec		r20
	rjmp	tens_lp		
zero_tens:	
	mov		r20,units
	subi	r20,0x30			;Convert to hex
	add		temp,r20				;Add remaining units to temp
	clr		r20
	adc		temp1,r20
	brvc	x_dtoh16			;Continue if not overflow
	set							;Indicate overflow
x_dtoh16:
	pop		r20	
	ret

